#!/usr/local/bin/perl 

# 6/1/2004 Author: Joe Barbish, I bequeath this perl script to public domain.
# It can be copied and distributed for free by anyone to anyone by any manner.  
# 5/1/2014 This script updated for RELEASE 10.0

print ("



  



           Welcome to the Proactive Abuse Reporting System.

In an effort to be proactive in doing my part to stop the massive quantities
of internet traffic probing for open ports or more specifically the probing 
for known ports that ms/windows spy ware, Trojans, and what ever other
ms/windows ports are commonly probed which result in increasing my bandwidth
usage changes, I wrote this perl application for reporting that abuse to the 
senders ISP, with the hopes they will monitor the abuser and terminate the
abuser's internet account. Even if the sending ip address is spoofed this
indicates the senders machine has a bot that the user is unaware of. 

This group of scripts are based on the log records created by the IPFILTER 
firewall. 


     Enter to continue\n");

$line =<STDIN>;
if ($line eq "\n") { print ("
This proactive abuse reporting system is comprised of 3 major process.

1. abuse.ipflog.rotate.pl :: This script is executed from within the cron 
   scheduling system. It checks to see if the ipfilter log file was rotated
   by the newsyslog command. If the ipfilter log file was rotated it launches
   the following scripts to process the log file creating abuse email reports
   containing the firewall log records. You must manually add the following 
   lines to /etc/crontab.

   # rotate ipfilter security log files every 10 min, if necessary
   */10  *   *   *    *    root    /usr/local/sbin/abuse.ipflog.rotate.pl

Manualy add the following to /etc/newsyslog.ipflog.conf.
#
# This is an special purpose conf file for ipfilter log data which is written 
# to /var/log/security. Every 10 minutes the etc/crontab file runs the 
# /usr/local/sbin/abuse.ipflog.rotate.pl script. This script issues the 
# newsyslog -v -f /etc/newsyslog.ipflog.conf /var/log/security command. If the 
# security file size is greater than 50k as defined in this file, then the IPF
# log will be rotated and the abuse scripts are run.
#
# logfilename     [owner:group]  mode count size when  flags [/pid_file]
/var/log/security                600  10    50   *     B    /var/run/syslog.pid

     Enter to continue");}
$line =<STDIN>;
if ($line eq "\n") { print ("





2. abuse.myisp.pl :: This script reads the ipf log, drops all log records
   not contained in the exclusion file, and creates an email containing all the
   ipf log records from source IP address belonging to your ISP which is 
   then emailed to your ISP's abuse department. The exclusion file contains
   only the IP address ranges owned by your ISP.
   <IE: Single email containing only your ISP abuse log records.>











     Enter to continue\n");}

$line =<STDIN>;
if ($line eq "\n") { print ("  



3. abuse.public.ISP0.pl :: This script first executes the 
   abuse.public.ISP1.pl script. It reads the ipf log, drops log 
   records based on the exclusion file, and writes a file. Then this script
   sorts the source IP address into sequence, performs an whois command to 
   harvest the abuse reporting email address of the ISP who owns the IP address
   range and then creates an email containing all the ipf log records for that
   offending source IP address which is then emailed to the owning ISP reporting 
   the probing abuse. The exclusion file contains only the IP address ranges 
   used on your private LAN if you have any and the IP address range owned 
   by your ISP.

   <IE: Single email per each abusing source IP address containing it's log 
    records is sent. This generates a lot of email. 99% of the abusive source
    IP address resolve to good owner ISP abuse reporting email address.
    RIPE and APNIC have merged their data into the whois.internic.org 
    database which makes this possible. There are still some South America 
    countries which have not as yet merged there data.> 

     Enter to continue");}
$line =<STDIN>;
if ($line eq "\n") { print ("






Installer instructions.  

This port has installed the following five scripts 
into /usr/local/sbin directory.
         abuse.ipflog.rotate.pl
         abuse.myisp.pl
         abuse.public.ISP0.pl
         abuse.public.ISP1.pl
         abuse.Reporting.system.pl

You have to edit the scripts and change the default email address in
the script source. Script contains comments explaining what needs to
be changed. In some cases you also have to create an exclude file,
follow instructions in the individual scripts about the syntax of
the exclude file contents.



\n");}


